*GUI Atari ST program Screen from GXP


* By P. Putnik, Jan. 2011.

* AES program for saving screenshots from savestates

* Displayed version is now 0.5




*First RSC object indices

; resource set indices for SCRFG
;
MAINDIAL equ 0 ; form/dialog
MAINDBOX equ 0 ; BOX in MAINDIAL
TITLE    equ 1 ; BOXTEXT in MAINDIAL
OPGFBU   equ 2 ; BUTTON in MAINDIAL
SAVBU    equ 3 ; BUTTON in MAINDIAL
EXITBU   equ 4 ; BUTTON in MAINDIAL
PRINFT   equ 5 ; TEXT in MAINDIAL



  include gemdmacr.s 
  include aes2macr.s     *Devpac3




progbeg

* Preparations : 

    move.l    4(sp),a4

* Mshrink needed because of Fileselector !

     lea         fin-progbeg+256,a1 *len of program and bss
     pea   	   (a1)
     move.l     (a4),-(sp)  *TPA begin
     move.w    #0,-(sp)
     move.w    #74,-(sp)
     trap #1                   
*    lea        12(sp),sp

*     move.l    4(sp),a4   *Basepage addr.
 
* Set stack in own space 
     lea         stack+560,sp
*     clr.l        (sp)
*     move.l    a4,4(sp)   *




aplinit
    appl_init

*Coordinate conversion-needed by integrated RSC
coordc
    moveq #0,d0

obfloop 
    move.w d0,obfia
    move.w d0,-(sp)

    rsrc_obfix
obfia  dc.w 0
    dc.l form1  *begin adress of objects

    move.w (sp)+,d0
    addq.b #1,d0
    cmp.b #rsc_obnum,d0 *
    bne.s obfloop





***********
* Setting current DIR for fileselector:

  *Get aktuell drive 
	move.w #25,-(sp)
	trap #1
	addq.l #2,sp

	move.w	d0,pathsto


	lea path(pc),a2  
	add.b #"A",d0
	move.b d0,(a2) 


* Add current DIR too ...

	clr.w         -(sp)   * Actuel drive
	pea	 pathbuf(pc)
	move.w     #71,-(sp)
	trap 	#1
	addq.l	#8,sp

* Put actual DIR in path:

 	lea	pathbuf+1(pc),a1
	lea	path+3(pc),a2
	tst.b	(a1)    * Are we in ROOT ?
	bne.s	set_l77
	subq.l	#1,a2    * Prevent double backslash
	bra.s	dirtop_end

set_l77	moveq	#77,d2    *limiter
dirtop_l 	tst.b	(a1)
	beq.s	dirtop_end
	move.b	(a1)+,(a2)+
	dbf	d2,dirtop_l

dirtop_end   
* Copy backslash, asterixes:
	lea	pathendp(pc),a1
	moveq	#4,d2
.ast	move.b	(a1)+,(a2)+
	dbf	d2,.ast


* set correct address for screenshow :

	lea   	buf+255(pc),a1
	move.l	a1,d1
	and.l	#$00FFFF00,d1
	move.l	d1,screenShB
	

* Save palette :

	pea	savPal(pc)
	move.w	#38,-(sp)
	trap	#14
	addq.l	#6,sp

* Get resolution :

	move.w	#4,-(sp)
	trap	#14
	addq.l	#2,sp

	move.w	d0,StartRes


* Get screen base :

	move.w	#2,-(sp)
	trap	#14
	addq.l	#2,sp

	move.l	d0,StartScreB



**********  End of preparations


mcontrl  bsr mctrl *program takes maus controll
  lea form1(pc),a0
  bsr opdial
  bsr resscp *screen part reserve
  bsr drdial

  move.l	sp,work_usp  *for keeping SP after subrut exit in menu

*Main loop of dialog    
mcont 
   move.l   work_usp(pc),sp

   bsr mafing *needed if is PRG (PRG startet with bee)
   bsr fodial

   move.w excod(pc),d0

  *Here come actions by button press


    cmp.w   #OPGFBU,d0
    beq    openGx
      
    cmp.w   #SAVBU,d0
    beq    savescr


    cmp.w    #EXITBU,d0
    beq cl2


menu
*  bsr mafing
    bsr exobdes  
    bra mcont



openGx   
* Select desired GXP file with File Selector, then
* show Screen,wait keypress ....


* First load savefile, so fileselector

	bsr     mabee
	lea     initst(pc),a1
	bsr     putext  *put initial extension

*Call fileselector:
	lea       fsloadm(pc),a1
	bsr       filesel
	tst.b     buffr+100
	beq      redrdial  * to dialog if nothing selected

*Open file  and load header:  

	move.w     #0,-(sp)   *read only
	pea         buffr+100(pc)
	move.w    #61,-(sp) *Open file
	trap         #1
	addq.l     #8,sp
*Error check
	tst.w       d0
	bmi         filerr

	move.w     d0,handl

	pea 	buf(pc)
	pea	256
	move.w    handl(pc),-(sp)
	move.w    #63,-(sp)
 	trap         #1
	lea          12(sp),sp
	cmp.l       #256,d0  *check 
	bne          filerr_clof


* Check signature
	lea 	buf(pc),a1
	cmp.l	#"PPGX",(a1)
	bne	notGamex




	move.l	24(a1),a5   * GameStat pos
	lea	248(a5),a5  * pos in file

* fseek there :
	clr.w  	-(sp)   *from file begin mode
	move.w    handl(pc),-(sp)
	pea	(a5)
	move.w  	#66,-(sp)  *fseek
	trap 	#1
	lea 	10(sp),sp

	pea	buf(pc)
	pea	70   * load GameStat block
	move.w    handl(pc),-(sp)
	move.w	#$3F,-(a7)
	trap	#1
	lea	12(sp),sp


	clr.w	colAlT   * preclear

	lea	buf(pc),a1
	move.w	4(a1),d1
	move.w	d1,gxcreRes   * resolution
	move.w	d1,degHead

	cmp.w	#2,d1
	bcs.s	inStColMod
	bne	skipShow	   * Skip show if  non-ST mode

* monochrome mode :
	cmp.w	#2,StartRes
*	bne	toColAl
	beq.s	setPal
	move.w	#3,colAlT    * flag
	bra.s	setPal

* ST low or medium :
inStColMod
	cmp.w	#2,StartRes
*	bcc	toMonAl
	bcs.s	setPal
	move.w	#1,colAlT    * flag

* Set palette :
setPal	lea	10(a1),a2

* Save palette in place for Degas header :

	move.l	a2,a1
	lea	degHead+2(pc),a3
	moveq	#15,d1
cop	move.w	(a1)+,(a3)+
	dbf	d1,cop

*	tst.w	colAlT
*	bne.s	skipScrCh0

* Following not good on Falcon
*	pea	(a2)
*	move.w	#6,-(sp)
*	trap	#14
*	addq.l	#6,sp




skipScrCh0
	
	lea	buf(pc),a1
	moveq	#0,d1
	move.b	66(a1),d1
	swap	d1
	move.b	67(a1),d1
	lsl.w	#8,d1
	move.l	d1,a2

	lea	248(a2),a5  * pos in file	
	clr.w  	-(sp)   *from file begin mode
	move.w    handl(pc),-(sp)
	pea	(a5)
	move.w  	#66,-(sp)  *fseek
	trap 	#1
	lea 	10(sp),sp

	tst.w	colAlT
	bne.s	skipScrCh1
	
	move.w	gxcreRes(pc),-(sp)   * Need first to check
* for high/color mode !!!
	move.l	screenShB(pc),-(sp)
	move.l	screenShB(pc),-(sp)
	move.w	#5,-(sp)
	trap	#14
	lea	12(sp),sp

* Palette set - best after setting screen !

	move.w	#37,-(sp)
	trap	#14
	addq.l	#2,sp

	pea	screPal(pc)
	move.w	#38,-(sp)
	trap	#14
	addq.l	#6,sp



skipScrCh1
* Load after screen set - because it erases buffer !
	move.l	screenShB(pc),-(sp)
	pea	32000
	move.w    handl(pc),-(sp)
	move.w	#$3F,-(a7)
	trap	#1
	lea	12(sp),sp



	bsr	closfile


	tst.w	colAlT
	bne.s	skipScrCh2

	move.w	#7,-(sp)
	trap	#1
	addq.l	#2,sp


* Restore  org screen

	pea	restPal(pc)
	move.w	#38,-(sp)
	trap	#14
	addq.l	#6,sp


	
	move.w	StartRes(pc),-(sp)   *
	move.l	StartScreB(pc),-(sp)
	move.l	StartScreB(pc),-(sp)
	move.w	#5,-(sp)
	trap	#14
	lea	12(sp),sp




toRedrD	bra	redrdial



skipShow		bsr	closfile

	bra.s	toRedrD


skipScrCh2	cmp.w	#3,colAlT
	beq.s	toColAl

toMonAl	lea	alertRl(pc),a0
	tst.w	gxcreRes
	beq.s	toAlCl
	
	lea	alertRm(pc),a0
	bra.s	toAlCl


toColAl	lea	alertRh(pc),a0
toAlCl	
	bra	to_alert1



	 
cl2  
   bsr mctab *vrati kontrolu

  
applex 
  appl_exit
  nop


  pterm0  *exit PRG
  nop




redrdial   bsr drdial
     bra menu  *back to dialog

colAlT	dc.w    0

***************

savescr


	bsr 	mabee
	lea 	pi1ex(pc),a1
	tst.w	gxcreRes
	beq.s	toPutE
	lea 	pi2ex(pc),a1
	cmp.w	#1,gxcreRes
	beq.s	toPutE
	cmp.w	#2,gxcreRes
	bne	redrdial    * Skip if not valid res
	lea 	pi3ex(pc),a1
toPutE	bsr 	putext  *put initial extension
*Call fileselector:
*pfilesel
	lea 	fssavem(pc),a1
	bsr 	filesel
	tst.b 	buffr+100
	beq 	redrdial  *dialog if nothing selected

	bsr 	autoext
	bsr 	mabee
	bsr 	drdial   *Must redraw it after filesel...

* Saving file :

*Create wanted filename
	move.w #0,-(sp)
	pea buffr+100(pc)
	move.w #60,-(sp) *Create file
	trap #1
	addq.l #8,sp
*Error check
	tst.w d0
	bmi filerr

	move.w d0,handl

	pea 	degHead(pc)
	pea	34
	move.w    handl(pc),-(sp)
	move.w    #64,-(sp)
 	trap         #1
	lea          12(sp),sp
 	cmp.l       #34,d0     *check 
	bne         filerr_clof2


	move.l	screenShB(pc),-(sp)	
	pea	32000
	move.w    handl(pc),-(sp)
	move.w    #64,-(sp)
 	trap         #1
	lea          12(sp),sp
 	cmp.l       #32000,d0     *check 
	bne         filerr_clof2

	bsr 	closfile
	bra	menu



* Header struct:
* Offset,	          meaning,		note
*     0	signature		PPGX
*     4	AltRamStart	new phystop, $80000 for 512KB games
*     8	Length of Swap area     usually  $7FCC8
*    12	TOS restoring code pos  usually  $FFD00
*    16	SysSto  pos	      usually   $FFF80
*    20	Game rest, code pos    usually   $7FD00 ???
*    24	GameStat   pos	    varies...
*    28	GameJmp      where to jump to continue game - varies
*    32      GamexKey code      $43  or $C3 for F9
*    33	GamePosS  code  ....
*    34	Special IKBD flag #1   	
*    35      STE   DMA   flag
*    36	Force Timer Data registers - for 4 timers, if not 0 force !
*    40	TOS saving loc  - if no GCOS then 256Kbytes + $108 after AltRamStart
*	it is when here is zero.  If here is some value then it
*	will be used as TOS saving loc - usually $C0108
*    44	Flag for loading and install  extra files ....
*	value   $0001  is for  D15R_NG1  at pos $C0100 !
*	will need some table for ...
*    46 Falcon cache settings, byte, + flag for validity = $CF
*    48  .....
















*****************



* Some constants, ofsets
mfpof	equ         42
ikbdof	equ	70
ikbdm_of   equ       100
srofs	equ	80
psgofs     equ	84
stedmaof    equ      108







******************

	





















filerr_clof2
     bsr      closfile
saverr
    lea     alertse(pc),a0
    bra.s  to_alert1

filerr_clof
     bsr      closfile
filerr  
    lea     alertde(pc),a0
to_alert1    bsr doalert

     bra     redrdial   *Needed after fileselector !

notGamex    bsr    closfile
     lea       alertnox(pc),a0
     bra.s    to_alert1



















* Restore Palette:
restPal
	lea	palSav(pc),a1
comPal	lea	$FFFF8240.w,a2
	moveq	#15,d1
.palc	move.w	(a1)+,(a2)+
	dbf	d1,.palc
	rts

savPal   * Save palette
	
	lea	palSav(pc),a1
	lea	$FFFF8240.w,a2
	moveq	#15,d1
.palc	move.w	(a2)+,(a1)+
	dbf	d1,.palc
	rts
	

screPal	
	lea	degHead+2(pc),a1	
	bra.s	comPal



gxcreRes	   dc.w  -1    * Flag that no screen to save
* here comes res of screen, so 0, 1 or 2  .


















  


closfile  move.w handl(pc),-(sp)
  move.w #62,-(sp)
  trap #1
  addq.l #4,sp
  rts

	

*AES dialog subrutines


*DRAW DIALOG SUBRUTINE
*In parameter:a0-tree adress

opdial *put tree adress on all places where needed 
  lea fca(pc),a1 
  move.l a0,(a1)
*  move.l a0,oda-fca(a1)
  move.l a0,fda-fca(a1)
  move.l a0,oca-fca(a1)
  move.l a0,oda2-fca(a1)
  move.l a0,oda2f-fca(a1)
  move.l a0,oda3-fca(a1)
*  move.l a0,oboff+2-fca(a1)
*centre objekt
  
  form_center
fca ds.l 1
*Enter coords
  lea cost(pc),a1 
  lea intout+2(pc),a0
  bsr.s copint2
  bsr.s copints
*  lea odp(pc),a1 
*  bsr.s copints
  lea odp2+4(pc),a1
  bsr.s copints
  lea fdf+2(pc),a1
  bsr.s copints
  bsr.s copints
  lea obnu+4(pc),a1
  
copints lea cost(pc),a0
copint2 moveq #3,d0
copil move.w (a0)+,(a1)+
  dbf d0,copil
  rts



*Reserve screen part
resscp
  form_dial
  dc.w 0
cost ds.w 8 
  rts



drdial 
  moveq #0,d0
  bra obdr  *ret via



*Object exit rutine "Form do"
  
fodial
   form_do
   dc.w 0
fda ds.l 1
   move.w intout(pc),excod  *Save exit button
   rts

cldial  bsr.s noredr

*Back screenpart
backsp
  form_dial
fdf dc.w 3
  ds.w 8

  rts

obsel move.w d0,obnu
  move.w #1,status
  bra.s ochl
obdes move.w d1,obnu
  bra.s clrstat

noredr  clr.w status+2  *No redraw by leave dialog
exobdes
  move.w excod(pc),obnu
clrstat  clr.w status  *normal status
ochl 
  objc_change
obnu dc.w 0,0,0,0,0,0
status  dc.w 0,1
oca ds.l 1
  move.w #1,status+2 * redraw needed after again
  rts



doalert
  move.l a0,ala
  form_alert
  dc.w 1  *Default
ala  dc.l 0 
  move.w intout(pc),d0
  cmp.w #1,d0 *test pressed key
  rts



obdr move.w d0,odp2
  objc_draw
odp2 dc.w 0,3 *depth=3 used
  ds.w 4
oda2 ds.l 1
  rts


clobdr  *startobject is mainbox 
  objc_draw
odp3 dc.w 0,2 *depth=2 used
clip3  ds.w 4
oda3 ds.l 1
  rts

obdrf move.w d0,odp2f
  bsr AEScall
  dc.w 42
odp2f dc.w 0,0
  ds.w 4
oda2f ds.l 1
  rts


mctrl
  wind_update
  dc.w 3
  rts

mctab
  wind_update
  dc.w 2
  rts

mafing moveq #3,d1
  bra.s grafmo
maarr moveq #0,d1
  bra.s grafmo
mabee moveq #2,d1
grafmo move.w d1,mousf
  graf_mouse
mousf dc.w 3
  dc.l 20000 *not used
  rts    






*Central rutine for param. adress serve etc.
AEScall  move.l (sp),a1  *reta
  move.w (a1)+,d0 *function number, a1 now hold intinadr (or reta)
  lea AESct-5(pc),a3
funsrl addq.l #5,a3
  cmp.b (a3),d0
  bne.s funsrl
  moveq #4,d1
  clr.l d0
  lea contrl(pc),a2
  move.l a2,a0
fuccl move.b (a3)+,d0
  move.w d0,(a2)+
  dbf d1,fuccl  
  
  lea AESPB(pc),a2
  move.l a1,8(a2) *pintin
  move.w 2(a0),d0  *# of intin
  lsl.w #1,d0  
  add.l d0,a1  *adress of addrin
  move.w 6(a0),d0
  beq.s noadrin
  move.l a1,16(a2) *paddrin
  lsl.w #2,d0  *mult by 4
  add.l d0,a1 
noadrin  move.l a1,(sp)  *Skip datas! -prepare retadress
  move.l a2,d1
  move.w #200,d0
  trap #2  *Call AES function
  rts


AESPB dc.l contrl  * pcontrol
pglobal dc.l global
pintin ds.l 1
pintout dc.l intout
paddrin ds.l 1
paddrout dc.l addrout

*Tables with AES control blocks of (only) used functions
AESct *must contents all in prg. used functions
  dc.b 10,0,1,0,0  *APPL init
  dc.b 19,0,1,0,0  *APPL exit
  dc.b 21,3,5,0,0  *EVNT button
  dc.b 23,0,1,1,0  *Evnt message
  dc.b 42,6,1,1,0  *Objc draw
  dc.b 43,4,1,1,0  *Objc find
  dc.b 44,1,3,1,0  *Objc offset
  dc.b 47,8,1,1,0  *Objc change
  dc.b 50,1,1,1,0  *Form do (dialog)
  dc.b 51,9,1,0,0  *Form dial
  dc.b 52,1,1,1,0  *Form alert
  dc.b 54,0,5,1,0  *Form center
  dc.b 78,1,1,1,0  *Graf mouse
  dc.b 79,0,5,0,0  *Graf mkstate
  dc.b 90,0,2,2,0  *Old Fsel for TOS 1.02 and 1.00
  dc.b 91,0,2,3,0  *Fsel input
  dc.b 107,1,1,0,0 *Wind update
  dc.b 114,1,1,1,0 *RSRC obfix
  dc.b 0
  even


filesel  clr.l buffr 
   
    tst.b oldtos
    bne.s fiselold

    move.l    a1,fsmadr
    fsel_i  
*  bsr AEScall
*  dc.w 91,0,2,3,0 *Only for new TOS!!!
   dc.l    path
   dc.l    buffr
fsmadr      ds.l  1  
    tst.w intout
    beq.s fisend
    tst.w intout+2
    beq.s fisend
  
fsok     lea buffr+100(pc),a1
     lea path(pc),a0
     bsr.s pdcopy
*Now drop attributes of select
droat 
    subq.l #1,a0
    cmp.b #"\",-(a1)  *is subdir end marker
    bne.s droat
    addq.l #1,a1  *move forward
    lea 2(a0),a2  *store ext (with . ) begin from path

    lea buffr(pc),a0
    tst.b (a0) *check for nothing selected or written
    beq.s fis2
    bra.s pdcopy
  
fisend 
fis2  clr.l buffr+100
     rts


fiselold  *AES 90 for older TOS

  fsel_input
  dc.l path
  dc.l buffr

  tst.w intout
  beq.s fisend
  tst.w intout+2
  beq.s fisend
  bra.s fsok



pdcopy 
    tst.b (a0)
    beq.s pdret 
    move.b (a0)+,(a1)+
    bra.s pdcopy

pdret move.b (a0),(a1)  *For case that longer was there prior
     rts


*Insert extension on path end
*a1 - pointer

putext lea path(pc),a0
searz  tst.b (a0)+
    bne.s searz
*Now search back for \
searbs cmp.b #"\",-(a0)
    bne.s searbs
    addq.l #1,a0

    moveq #5,d1  *copy 4-5 chars and zero term.
initc move.b (a1)+,(a0)+
    dbf d1,initc
    clr.b (a0)
    rts  


autoext    moveq #3,d1
aecl     move.b (a2),(a1)+
    move.b    (a2)+,(a0)+ *copy in name too -for MK LDER
    dbf      d1,aecl *copy extension from path
    clr.b    (a0)
    clr.b     (a1) *endmarker   
    rts




*The RSC integrated - source made with RSCTOASM


rsc_obnum equ  6



*rsc_obs	dc.w	5	* 6 objects in RSC *

form1	dc.w	-1,1,5
	dc.w	20,0,16		*0*
	dc.l	$21113
	dc.w	1,1,35,13

	dc.w	2,-1,-1
	dc.w	22,0,0		*1*
	dc.l	ted1
	dc.w	$501,$500,$51F,1

	dc.w	3,-1,-1
	dc.w	26,5
	dc.b	0
flag1	dc.b	0		*2*
	dc.l	text1
	dc.w	$303,3,$411,$701

	dc.w	4,-1,-1
	dc.w	26,5
	dc.b	0
flag2	dc.b	0		*3*
	dc.l	text2
	dc.w	$408,$106,17,$102

	dc.w	5,-1,-1
	dc.w	26,5
	dc.b	0
flag3	dc.b	0		*4*
	dc.l	text3
	dc.w	$714,$309,$50B,$102

	dc.w	0,-1,-1
	dc.w	21,32,0		*5*
	dc.l	ted2
	dc.w	1,$20B,$30D,$101

		* Tedinfo blocks *

ted1	dc.l	text4,null,null
	dc.w	3,6,2,$1180
	dc.w	0,-1,27,1

ted2	dc.l	text5,null,null
	dc.w	5,6,0,$1180
	dc.w	0,-1,18,1

		* Text data *

text1	dc.b	'Open GXP file',0
text2	dc.b	'Save screenshot',0
text3	dc.b	'E X I T',0
text4	dc.b	'Screen saver from GXP file',0
text5	dc.b	'V 0.5  by PP 2011',0
null	dc.b	0,0






alertde	dc.b	'[3][|Load error!][Damn!]',0 
alertse	dc.b	'[3][|Save error!][Damn!]',0 

alertnox     dc.b	'[3][|Not gamestate file !][ Ah ]',0 


alertRh	dc.b	"[1][Can't display screenshot|but you may save it|"
      dc.b    'as PI3 high-res Degas file.][OK]',0 

alertRl	dc.b	"[1][Can't display screenshot|but you may save it|"
      dc.b    'as PI1 low-res Degas file.][OK]',0 

alertRm	dc.b	"[1][Can't display screenshot|but you may save it|"
      dc.b    "as PI2 medium-res Degas file.][OK]",0 


	even

work_usp      dc.l  0   *for restoring USP after some subrut exits, by error usually

pathsto	   dc.w     0


***** File selector stuff:

initst   dc.b   "*.GXP",0,0
pi1ex  dc.b  "*.PI1",0,0
pi2ex  dc.b  "*.PI2",0,0
pi3ex  dc.b  "*.PI3",0,0

  
fsloadm dc.b "Open GXP file ...",0

fssavem dc.b "Save screen ..",0

********

pathendp   dc.b  "\*.*",0



   even

oldtos dc.w 0
errflag ds.w 0

*Put here current drive.... :
path dc.b  "D:\*.*",0,0,0

  even

  SECTION BSS

  ds.b 512  *place for path

excod ds.w 1


contrl ds.w 5
global ds.l 16  
intout ds.w 7  *max 7
addrout ds.l 2  *max 2
emb ds.w 8  


filelen ds.l 1
handl ds.w 1


StartRes	   ds.w  1
StartScreB   ds.l  1
screenShB   ds.l   1

pathbuf  ds.b  200   * 

buffr      ds.b 512    * 

palSav    ds.b   32

deghead   ds.b   34
buf	ds.b  33000





stack     ds.b 568   *

fin



